<script>
import { validationMixin } from "vuelidate";
import { required, minLength } from "vuelidate/lib/validators";
import { mapActions } from "vuex";

export default {
  mixins: [validationMixin],

  validations: {
    login: { required },
    password: { required, minLength: minLength(8) },
  },

  data() {
    return {
      login: "",
      password: "",
      showPassword: false,

      loading: false,
    };
  },

  computed: {
    loginErrors() {
      const errors = [];
      if (!this.$v.login.$dirty) return errors;
      !this.$v.login.required && errors.push("Обязательное поле");
      return errors;
    },

    passwordErrors() {
      const errors = [];
      if (!this.$v.password.$dirty) return errors;
      !this.$v.password.minLength &&
        errors.push("Пароль должен состоять минимум из 8 символов");
      !this.$v.password.required && errors.push("Обязательное поле");
      return errors;
    },
  },

  methods: {
    ...mapActions({
      auth: "auth/auth",
      checkUser: "user/checkUser",
    }),

    submit() {
      this.$v.$touch();
      this.loading = true;

      this.auth({ login: this.login, password: this.password })
        .then(() => {
          this.clear();
          this.$router.push({ name: "Home" });
        })
        .finally(() => {
          this.loading = false;
        });
    },

    clear() {
      this.$v.$reset();
      this.login = "";
      this.password = "";
    },
  },
};
</script>

<template>
  <div class="auth">
    <h1 class="auth__title">Вход в систему</h1>

    <div class="auth__block block-wrapper">
      <img class="mb-4" src="../assets/logo_auth.svg" alt="" />

      <h2 class="block__title">Авторизируйтесь</h2>

      <form>
        <v-text-field
          v-model="login"
          outlined
          dense
          :error-messages="loginErrors"
          label="Логин"
          required
          @input="$v.login.$touch()"
          @blur="$v.login.$touch()"
        ></v-text-field>

        <v-text-field
          v-model="password"
          outlined
          dense
          :error-messages="passwordErrors"
          :append-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"
          :type="showPassword ? 'text' : 'password'"
          name="input-10-1"
          label="Пароль"
          hint="Минимум 8 символов"
          @click:append="showPassword = !showPassword"
          @input="$v.password.$touch()"
          @blur="$v.password.$touch()"
        ></v-text-field>

        <v-btn
          class="auth__btn"
          large
          elevation="0"
          :loading="loading"
          @click="submit"
        >
          Войти
        </v-btn>
      </form>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.auth {
  height: 100%;
  width: 100%;
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 96px 32px 60px;

  &__title {
    color: #fff;
    margin-bottom: 64px;
    font-size: 40px;
  }

  &__block {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    max-width: 570px;
    width: 100%;
    padding: 32px 0 48px;

    .v-input {
      width: 320px;
    }
  }

  .block {
    &__title {
      margin-bottom: 40px;
      font-size: 32px;
      font-weight: 500;
    }
  }

  &__btn {
    width: 100%;
    margin-top: 2px;
    background-color: #179de3 !important;
    color: #fff !important;
  }
}
</style>
